//1. Container radius search with a variable radius, default 10.
//2. Find first player's client.
//3. Raycast to the player, making sure there is nothing in the line of sight.
//4. Send command to client to use dot product and calculate if the screen is in view.
//5. If player is looking, flash images on screen and damage.
//6.Find next player and repeat until returning 0.
//7. Schedule once every 0.5 - 1 seconds.
package SCP895
{
function isInMinigame(%player)
{
	if(isobject(%player))
	{
		if(%player.getclassname() $= "Player")
		{
			if(%player.client.minigame != 0 && %player.client.minigame != -1)
			{
				return 1;

			}
		}
		if(%player.getclassname() $= "AiPlayer")
		{
			if(%player.spawnbrick.getgroup().client.minigame != 0 && %player.spawnbrick.getgroup().client.minigame != -1)
			{
				return 1;
			}
		}
		return 0;
	}
}

function servercmdset895radius(%client, %num)
{
	if(%client.isHost || %client.isSuperAdmin || %client.isAdmin)
	{
		$rad = %num;
		%client.chatmessage("\c3SCP-895's radius has been set to " @ %num);
	}
	else
	{
		%client.chatmessage("\c3You do not have permission do do this!");
	}
}
function fxDtsBrick::onPlant(%brick)
{
	parent::onPlant(%brick);
	if(%brick.getDatablock().scp895)
	{
		%client = %brick.getGroup().client;
		if(%client.isHost || %client.isSuperAdmin || %client.isAdmin)
		{
			if(!$rad)
			{
				$rad = 10;
			}
			%brick.name = "SCP-895";
			%brickTransform = %brick.getPosition();
			getPlayers(%brickTransform, %brick);
			%brick.setPrint($printNameTable1x1["/8950"]);
			Parent::onPlant(%brick);
		}
		else
		{
			%brick.killBrick();
			%client.chatmessage("\c3You do not have permission do this!");
			
		}
	}
	
}
function fxDtsBrick::onLoadPlant(%brick)
{
	parent::onLoadPlant(%brick);
	if(%brick.getDatablock().scp895)
	{
		if(!$rad)
		{
			$rad = 10;
		}
		%brick.name = "SCP-895";
		%brickTransform = %brick.getPosition();
		getPlayers(%brickTransform, %brick);
		%brick.setPrint($printNameTable1x1["/8950"]);
		Parent::onLoadPlant(%brick);
	}
}
function fxDtsBrick::onRemove(%brick)
{
	parent::onRemove(%brick);
	if(%brick.getDatablock().scp895)
	{
		cancel($find[%brick]);
		cancel($schedule[%brick]);
	}
}
function fxDtsBrick::onKill(%brick)
{
	parent::onKill(%brick);
	if(%brick.getDatablock().scp895)
	{
		cancel($find[%brick]);
		cancel($schedule[%brick]);
	}
}
function startFlashing(%brick)
{
	%print = getRandom(7);
	switch(%print)
	{
	case 0:
		if(isObject(%brick)){%brick.setPrint($printNameTable1x1["/8950"]);}
	case 1:
		if(isObject(%brick)){%brick.setPrint($printNameTable1x1["/8951"]);}
	case 2:
		if(isObject(%brick)){%brick.setPrint($printNameTable1x1["/8952"]);}
	case 3:
		if(isObject(%brick)){%brick.setPrint($printNameTable1x1["/8953"]);}
	case 4:
		if(isObject(%brick)){%brick.setPrint($printNameTable1x1["/8954"]);}
	case 5:
		if(isObject(%brick)){%brick.setPrint($printNameTable1x1["/8955"]);}
	case 6:
		if(isObject(%brick)){%brick.setPrint($printNameTable1x1["/8956"]);}
	case 7:
		if(isObject(%brick)){%brick.setPrint($printNameTable1x1["/8957"]);}
	}
	if($found)
	{
		$schedule[%brick] = schedule(1800, 0, "startFlashing", %brick);
	}
	else
	{
		if(isObject(%brick)){%brick.setPrint($printNameTable1x1["/8950"]);}
	}
}
function getPlayers(%pos, %brick)
{
	InitContainerRadiusSearch(%pos, $rad, $TypeMasks::PlayerObjectType);
	while((%target = ContainerSearchNext()) != 0)
	{
		if(isInMinigame(%target))
		{
			%vectorToTarget = VectorSub(%pos, %target.getEyePoint());
			%vectorToTarget = VectorNormalize(%vectorToTarget);
			%forwardVector = %target.getEyeVector(); %dot = VectorDot(%vectorToTarget,%forwardVector);
			%angle = mDegToRad(%target.getCameraFOV()/2); %angle = mCos(%angle);
			if(%dot > %angle)
			{
				if(containerRayCast(%pos, %target.getPosition(), $TypeMasks::All) == %target)
				{
					if(!$found)
					{
						%shouldFlash = true;
					}
					$found = true;
					if((%target.getDatablock().maxDamage - %target.getDamageLevel()) <= 10)
					{
						messageAll("",%target.client.name@" was killed by SCP-895");
					}
					%target.damage(%brick, %target.getPosition(), 10, "");
					
					if(%shouldFlash)
					{	
						startFlashing(%brick);
						%shouldFlash = false;
					}
				}
			}
			else
			{
				$found = false;
			}
		}
	}
	if((%target = ContainerSearchNext()) == 0)
	{
		$found = false;
	}
	$find[%brick] = schedule(500, 0, "getPlayers", %pos, %brick);
}
};
activatePackage(SCP895);